﻿using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using System.Runtime.Serialization; 
using System.Runtime.Serialization.Formatters.Binary; 
using System.Text;
using System.Threading;
using System.Net.Sockets ;
using System.IO ;


namespace cClient
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class frmMain : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.ListBox lbClients;

		private TcpClient socketForServer ;
		private Thread tClientThread;
		public StreamWriter streamwriter;
		public StreamReader streamreader;
		public Hashtable privateChatWindows;
		public string userName;

		//For FTP Server
		private TcpListener tcpListener;
		private Socket socketForClient;
		private Thread ftpMainThread;
		private ArrayList tClientThreads;
		private ArrayList tFTPSockets;
		//End declaration for FTP server with in client
		
		public Protocol.Crypto encrypter;
		public Protocol.Crypto decrypter;
		public Protocol.RSAKeyCreator keys;
		public Protocol.Certificate serverCertificate;

		public string clientIP;
		public int clientPort = 0;

		string base64String;
		string hashValue;
		string fileName;

		private System.Windows.Forms.Button button3;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.TextBox tbPassword;
		private System.Windows.Forms.TextBox tbUserName;
		private System.Windows.Forms.Button button2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.TextBox tbPort;
		private System.Windows.Forms.TextBox tbIP;
		private System.Windows.Forms.Button button4;
		private System.Windows.Forms.OpenFileDialog openFileDialog1;
		private System.Windows.Forms.SaveFileDialog saveFileDialog1;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.TextBox tbFtpPort;
		private System.Windows.Forms.ListBox lbFiles;
		private System.Windows.Forms.Button button5;
		private System.Windows.Forms.Label label6;
		private System.Windows.Forms.Label label7;
		private System.Windows.Forms.Label label8;

		public delegate void processPrivateChatDelegate(string message);
		public delegate void processNewUserDelegate(string message);
		public delegate void processUserLeftDelegate(string message);
		public delegate void processServerCertificateDelegate(string message);
		public delegate void processFTPInfoMsgDelegate(string message);
		
		public delegate void processFileList(string message);
		public delegate void processNewFileReceived(string message);
		
		
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public frmMain()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			privateChatWindows = new Hashtable();
			keys = new Protocol.RSAKeyCreator();
			serverCertificate = new Protocol.Certificate();
			tClientThreads = new ArrayList();
			tFTPSockets = new ArrayList();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			GetMemoryBack();
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.button1 = new System.Windows.Forms.Button();
			this.lbClients = new System.Windows.Forms.ListBox();
			this.button3 = new System.Windows.Forms.Button();
			this.label2 = new System.Windows.Forms.Label();
			this.label1 = new System.Windows.Forms.Label();
			this.tbPassword = new System.Windows.Forms.TextBox();
			this.tbUserName = new System.Windows.Forms.TextBox();
			this.button2 = new System.Windows.Forms.Button();
			this.label3 = new System.Windows.Forms.Label();
			this.label4 = new System.Windows.Forms.Label();
			this.tbPort = new System.Windows.Forms.TextBox();
			this.tbIP = new System.Windows.Forms.TextBox();
			this.button4 = new System.Windows.Forms.Button();
			this.openFileDialog1 = new System.Windows.Forms.OpenFileDialog();
			this.saveFileDialog1 = new System.Windows.Forms.SaveFileDialog();
			this.tbFtpPort = new System.Windows.Forms.TextBox();
			this.label5 = new System.Windows.Forms.Label();
			this.lbFiles = new System.Windows.Forms.ListBox();
			this.button5 = new System.Windows.Forms.Button();
			this.label6 = new System.Windows.Forms.Label();
			this.label7 = new System.Windows.Forms.Label();
			this.label8 = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// button1
			// 
			this.button1.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.button1.Location = new System.Drawing.Point(111, 132);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(80, 24);
			this.button1.TabIndex = 0;
			this.button1.Text = "Свързване";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// lbClients
			// 
			this.lbClients.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lbClients.HorizontalScrollbar = true;
			this.lbClients.Location = new System.Drawing.Point(0, 184);
			this.lbClients.Name = "lbClients";
			this.lbClients.Size = new System.Drawing.Size(288, 56);
			this.lbClients.TabIndex = 5;
			// 
			// button3
			// 
			this.button3.Enabled = false;
			this.button3.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.button3.Location = new System.Drawing.Point(199, 132);
			this.button3.Name = "button3";
			this.button3.Size = new System.Drawing.Size(88, 24);
			this.button3.TabIndex = 6;
			this.button3.Text = "Изключване";
			this.button3.Click += new System.EventHandler(this.button3_Click);
			// 
			// label2
			// 
			this.label2.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label2.Location = new System.Drawing.Point(0, 32);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(72, 16);
			this.label2.TabIndex = 10;
			this.label2.Text = "Парола:";
			// 
			// label1
			// 
			this.label1.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label1.Location = new System.Drawing.Point(0, 8);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(72, 16);
			this.label1.TabIndex = 9;
			this.label1.Text = "Потр. име:";
			// 
			// tbPassword
			// 
			this.tbPassword.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.tbPassword.Location = new System.Drawing.Point(113, 32);
			this.tbPassword.MaxLength = 10;
			this.tbPassword.Name = "tbPassword";
			this.tbPassword.PasswordChar = '*';
			this.tbPassword.Size = new System.Drawing.Size(176, 21);
			this.tbPassword.TabIndex = 8;
			this.tbPassword.Text = "";
			// 
			// tbUserName
			// 
			this.tbUserName.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.tbUserName.Location = new System.Drawing.Point(113, 8);
			this.tbUserName.MaxLength = 10;
			this.tbUserName.Name = "tbUserName";
			this.tbUserName.Size = new System.Drawing.Size(176, 21);
			this.tbUserName.TabIndex = 7;
			this.tbUserName.Text = "";
			// 
			// button2
			// 
			this.button2.Enabled = false;
			this.button2.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.button2.Location = new System.Drawing.Point(103, 340);
			this.button2.Name = "button2";
			this.button2.Size = new System.Drawing.Size(80, 24);
			this.button2.TabIndex = 11;
			this.button2.Text = "Закрит чат";
			this.button2.Click += new System.EventHandler(this.button2_Click_1);
			// 
			// label3
			// 
			this.label3.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label3.Location = new System.Drawing.Point(0, 84);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(112, 16);
			this.label3.TabIndex = 15;
			this.label3.Text = "Порт на сървърът:";
			// 
			// label4
			// 
			this.label4.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label4.Location = new System.Drawing.Point(0, 60);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(96, 16);
			this.label4.TabIndex = 14;
			this.label4.Text = "IP на сървърът:";
			// 
			// tbPort
			// 
			this.tbPort.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.tbPort.Location = new System.Drawing.Point(113, 81);
			this.tbPort.MaxLength = 10;
			this.tbPort.Name = "tbPort";
			this.tbPort.Size = new System.Drawing.Size(176, 21);
			this.tbPort.TabIndex = 13;
			this.tbPort.Text = "8100";
			// 
			// tbIP
			// 
			this.tbIP.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.tbIP.Location = new System.Drawing.Point(113, 57);
			this.tbIP.MaxLength = 100;
			this.tbIP.Name = "tbIP";
			this.tbIP.Size = new System.Drawing.Size(176, 21);
			this.tbIP.TabIndex = 12;
			this.tbIP.Text = "127.0.0.1";
			// 
			// button4
			// 
			this.button4.Enabled = false;
			this.button4.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.button4.Location = new System.Drawing.Point(190, 340);
			this.button4.Name = "button4";
			this.button4.Size = new System.Drawing.Size(97, 24);
			this.button4.TabIndex = 16;
			this.button4.Text = "Изпрати файл";
			this.button4.Click += new System.EventHandler(this.button4_Click);
			// 
			// openFileDialog1
			// 
			this.openFileDialog1.FileOk += new System.ComponentModel.CancelEventHandler(this.openFileDialog1_FileOk);
			// 
			// tbFtpPort
			// 
			this.tbFtpPort.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.tbFtpPort.Location = new System.Drawing.Point(113, 105);
			this.tbFtpPort.MaxLength = 10;
			this.tbFtpPort.Name = "tbFtpPort";
			this.tbFtpPort.Size = new System.Drawing.Size(176, 21);
			this.tbFtpPort.TabIndex = 17;
			this.tbFtpPort.Text = "9100";
			// 
			// label5
			// 
			this.label5.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label5.Location = new System.Drawing.Point(0, 108);
			this.label5.Name = "label5";
			this.label5.Size = new System.Drawing.Size(72, 16);
			this.label5.TabIndex = 18;
			this.label5.Text = "FTP порт:";
			// 
			// lbFiles
			// 
			this.lbFiles.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lbFiles.HorizontalScrollbar = true;
			this.lbFiles.Location = new System.Drawing.Point(0, 256);
			this.lbFiles.Name = "lbFiles";
			this.lbFiles.ScrollAlwaysVisible = true;
			this.lbFiles.Size = new System.Drawing.Size(288, 82);
			this.lbFiles.Sorted = true;
			this.lbFiles.TabIndex = 19;
			// 
			// button5
			// 
			this.button5.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.button5.Location = new System.Drawing.Point(1, 340);
			this.button5.Name = "button5";
			this.button5.Size = new System.Drawing.Size(96, 24);
			this.button5.TabIndex = 20;
			this.button5.Text = "Приеми файл";
			this.button5.Click += new System.EventHandler(this.button5_Click);
			// 
			// label6
			// 
			this.label6.Font = new System.Drawing.Font("Arial", 6.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.label6.Location = new System.Drawing.Point(8, 132);
			this.label6.Name = "label6";
			this.label6.Size = new System.Drawing.Size(88, 23);
			this.label6.TabIndex = 21;
			this.label6.Text = "PhotonSoft Ltd. Daniel Denev";
			this.label6.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// label7
			// 
			this.label7.Location = new System.Drawing.Point(0, 240);
			this.label7.Name = "label7";
			this.label7.Size = new System.Drawing.Size(64, 16);
			this.label7.TabIndex = 22;
			this.label7.Text = "Файлове:";
			// 
			// label8
			// 
			this.label8.Location = new System.Drawing.Point(0, 164);
			this.label8.Name = "label8";
			this.label8.Size = new System.Drawing.Size(88, 16);
			this.label8.TabIndex = 23;
			this.label8.Text = "Потребители:";
			// 
			// frmMain
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(6, 14);
			this.ClientSize = new System.Drawing.Size(288, 365);
			this.Controls.Add(this.label8);
			this.Controls.Add(this.label7);
			this.Controls.Add(this.label6);
			this.Controls.Add(this.button5);
			this.Controls.Add(this.lbFiles);
			this.Controls.Add(this.tbFtpPort);
			this.Controls.Add(this.tbPort);
			this.Controls.Add(this.tbIP);
			this.Controls.Add(this.tbPassword);
			this.Controls.Add(this.tbUserName);
			this.Controls.Add(this.label5);
			this.Controls.Add(this.button4);
			this.Controls.Add(this.label3);
			this.Controls.Add(this.label4);
			this.Controls.Add(this.button2);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.button3);
			this.Controls.Add(this.button1);
			this.Controls.Add(this.lbClients);
			this.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.MaximizeBox = false;
			this.Name = "frmMain";
			this.Text = "Клиент";
			this.Closing += new System.ComponentModel.CancelEventHandler(this.frmMain_Closing);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			// TcpListener tcpListener = new TcpListener(System.Net.IPAddress.Parse("127.0.0.1"), 9100) ;
			//tcpListener.Start() ;
			//string ip = tcpListener.LocalEndpoint.ToString();
			Application.Run(new frmMain());
		}
		private void GetMemoryBack()
		{
			if(ftpMainThread != null && ftpMainThread.IsAlive)
			{
				ftpMainThread.Abort();
			}
			if(tcpListener != null)
				tcpListener.Stop();
			if (socketForClient != null && socketForClient.Connected)
			{
				socketForClient.Close();
			}
			if(tClientThread != null && tClientThread.IsAlive)
			{
				tClientThread.Abort();
			}
			for(int i=0;i<tFTPSockets.Count;i++)
			{
				FTPThread ftpThread = (FTPThread) tFTPSockets[i];
				ftpThread.closeConnections();
				ftpThread = null;
			}
			for(int i=0;i<tClientThreads.Count;i++)
			{
				Thread client = (Thread) tClientThreads[i];
				if(client.IsAlive)
				{
					client.Abort();
				}
			}

			if(streamreader != null)
			{
				streamreader.Close();
			}
			if(streamwriter != null)
			{
				streamwriter.Close();
			}
			if(socketForServer != null)
			{
				socketForServer.Close();
			}
		}
		private void button1_Click(object sender, System.EventArgs e)
		{
			try
			{
				//socketForServer = new TcpClient(tbIP.Text.Trim(),tbPort.Text.Trim()) ;
				socketForServer = new TcpClient(tbIP.Text.Trim(),int.Parse( tbPort.Text.Trim()) ) ;		

				
			}
			catch (Exception ex)
			{
				MessageBox.Show("Unable to connect to server","Server Unavialable",MessageBoxButtons.OK);				
				return ;
			}
			try
			{
				
				string hostName = System.Net.Dns.Resolve("localhost").HostName;
				System.Net.IPAddress addr = System.Net.Dns.Resolve(hostName).AddressList[0];
				tcpListener = new TcpListener(addr,int.Parse( tbFtpPort.Text.Trim())) ;
				tcpListener.Start() ;
			}
			catch(Exception exe)
			{
				
			}
			button1.Enabled = false;
			button3.Enabled = true;
			button2.Enabled = true;
			button4.Enabled = true;
			button5.Enabled = true;
			decrypter = new Protocol.Crypto(keys.PrivateKeyXml);

			tClientThread=new Thread(new ThreadStart(run));
			tClientThread.Name="Client Thread";
			tClientThread.Start();

			ftpMainThread = new Thread(new ThreadStart(ftpServerMain));
			ftpMainThread.Name = "FTP Thread";
			ftpMainThread.Start();
		}

		void ftpServerMain()
		{
			while (true)
			{
				socketForClient = tcpListener.AcceptSocket() ;
				
				
				FTPThread clientFTPObj=new FTPThread();
				clientFTPObj.socketForClient=socketForClient;
				clientFTPObj.mainForm = this;

				tFTPSockets.Add(clientFTPObj);

				//Start the FTP client thread for receiving a new file
				Thread tClientThread=new Thread(new ThreadStart(clientFTPObj.run));
				tClientThread.Name="FTP Client Thread";
				tClientThreads.Add (tClientThread);
				tClientThread.Start();
			}
		}
		//This thread sends the file to the other client
		void sendFile()
		{
			
			TcpClient socketForFTP = new TcpClient(clientIP,clientPort);
			NetworkStream networkStream = socketForFTP.GetStream() ;

			StreamReader ftpStreamReader = new StreamReader(networkStream) ;
			StreamWriter ftpStreamWriter = new StreamWriter(networkStream) ;


			ftpStreamWriter.WriteLine(userName);
			ftpStreamWriter.Flush();

			ftpStreamWriter.WriteLine(fileName);
			ftpStreamWriter.Flush();
			

			ftpStreamWriter.WriteLine(hashValue);
			ftpStreamWriter.Flush();


			ftpStreamWriter.WriteLine(base64String);
			ftpStreamWriter.Flush();

			ftpStreamReader.Close();
			ftpStreamWriter.Close();

			networkStream.Close();

			socketForFTP.Close();
		}
		void run()
		{
			NetworkStream networkStream = socketForServer.GetStream() ;
			streamreader = new StreamReader(networkStream) ;
			streamwriter = new StreamWriter(networkStream) ;

			string clientmessage ;
			bool doesExit = false;

			//Sends a login request
			sendLoginRequest();

			while (true)
			{
				if(doesExit)
				{
					//Now this client has disconnected so release all the resources
					closeConnections();
					break;
				}

				//This returns the message ID by the client
				char msgID = '0';
				if(encrypter == null)
				{
					msgID = (char) streamreader.Read();
					clientmessage = streamreader.ReadLine();
				}
				else
				{
					clientmessage = streamreader.ReadLine();
					string encryptedMsg = decrypter.Decrypt(clientmessage);
					msgID = encryptedMsg[0];
					clientmessage = encryptedMsg.Substring(1);
				}
				switch(msgID)
				{
						
					case '3':
						Invoke(new processNewUserDelegate(processNewUserMessage), new object [] { clientmessage });
						break;
					case '4':
						Invoke(new processUserLeftDelegate(processUserLeftMessage), new object [] { clientmessage });
						break;
						//5=users list followed by $ seperated list
					case '5':
						processOnlineUsersList(clientmessage);
						break;
					//7=Error Message follwoed by a message
					case '7':
						processMessage(clientmessage);
						enableButtons();
						doesExit = true;
						break;
					case '9':
						Invoke(new processPrivateChatDelegate(processPrivateMessage), new object [] { clientmessage });
						break;
					case 'u':
						Invoke(new processFTPInfoMsgDelegate(processFTPInfoMsg), new object [] { clientmessage });
						break;
					//server sends the list of available files for download at server
					case 'f':
						Invoke(new processFileList(processFileListMsg), new object [] { clientmessage });
						break;
					case 'r':
						Invoke(new processNewFileReceived(processNewFileReceivedMsg), new object [] { clientmessage });
						break;
					//for sucessfull messages
					case 's':
						processMessage(clientmessage);
						break;

				}
						
			}
		}
		private void enableButtons()
		{
			button3.Enabled = false;
			button1.Enabled = true;
			button2.Enabled = false;
			button4.Enabled = false;
		}
		private void processNewFileReceivedMsg(string message)
		{
			string crcValue = message.Split("$".ToCharArray())[0];

			button5.Enabled=false;

			string fileName = streamreader.ReadLine();
			string fileDetails = streamreader.ReadLine();

			byte [] crcData = System.Convert.FromBase64String(crcValue);
			
			byte [] data = System.Convert.FromBase64String(fileDetails);
			 
			Protocol.CRC32 crc = new Protocol.CRC32();
			crc.Initialize();

			if(crc.VerifyHash(data,crcData))
			{
				string  outputFileName=@"C:\clienttemp\" + fileName;
				System.IO.FileStream outFile = new FileStream(outputFileName, FileMode.CreateNew);
				outFile.Write(data, 0, data.Length);
				outFile.Close();
				MessageBox.Show("File " + fileName + " is copied successfully to default directory.","File Copied");
			}
			else
			{
				MessageBox.Show("CRC check fails.Unable to copy file!!","File CRC Error");
			}
			button5.Enabled=true;
		}
		private void processFileListMsg(string message)
		{
			string [] filelist = message.Split("$".ToCharArray());
			for(int i=0;i<filelist.Length-1;i++)
			{
				lbFiles.Items.Add(filelist[i]);
			}
		}
		private void processFTPInfoMsg(string message)
		{
			string clientIP = message.Split("$".ToCharArray())[0];
			string clientPort = message.Split("$".ToCharArray())[1];

			this.clientIP = clientIP;
			this.clientPort = int.Parse( clientPort );

			if(this.clientIP != null && this.clientPort != 0 && this.clientIP != string.Empty)
			{
				openFileDialog1.ShowDialog(this);
			}
		}
		private void processServerCertificate(string message)
		{
			string serverPublicKey = message.Split("$".ToCharArray())[0];
			string serverValidDates = message.Split("$".ToCharArray())[1];
			string serverVersion = message.Split("$".ToCharArray())[2];
			string serverIssuerName = message.Split("$".ToCharArray())[3];

			serverCertificate.publicKey = serverPublicKey;
			serverCertificate.validDates = serverValidDates;
			serverCertificate.version = serverVersion;
			serverCertificate.issuerName = serverIssuerName;

			sendMessage("6"+keys.PublicKeyXml+"$$$$");

			//create the decrypter object with the public key of client
			encrypter = new Protocol.Crypto(serverPublicKey);

			//Share the public keys with server
			

		}
		public void sendMessage(string message)
		{
			try
			{
				if(encrypter != null)
					streamwriter.WriteLine(encrypter.Encrypt(message).ToString());
				else
					streamwriter.WriteLine(message);
				streamwriter.Flush();
			}
			catch(Exception ex)
			{
				
			}
		}
		private void processNewUserMessage(string message)
		{
			string uName = message.Split("$".ToCharArray())[0];
			lbClients.Items.Add(uName);
		}
		private void processUserLeftMessage(string message)
		{
			string uName = message.Split("$".ToCharArray())[0];
			lbClients.Items.Remove(uName);
		}
		private void processPrivateMessage(string message)
		{
			string destUName = message.Split("$".ToCharArray())[0];
			string destMessage = message.Substring(message.IndexOf("$")+1);
			destMessage = destMessage.Substring(0,destMessage.Length-1);

			//Windows Already opened
			if(privateChatWindows.Contains(destUName))
			{
				frmChatWindow chatWindow = (frmChatWindow) privateChatWindows[destUName];
				chatWindow.setText(destUName + ":" +destMessage);
			}
				//The user has close the window
			else
			{
				frmChatWindow chatWindow = new frmChatWindow(destUName,this);
				chatWindow.Visible = true;
				chatWindow.Text += "~" + destUName;
				chatWindow.setText(destUName + ":" +destMessage);
				privateChatWindows.Add(destUName,chatWindow);
				
			}
		}
		private void closeConnections()
		{
			if(streamreader != null)
				streamreader.Close();
			if(streamwriter != null)
				streamwriter.Close();
			if(socketForServer != null)
				socketForServer.Close();
		}
		private void processMessage(string message)
		{
			string caption = message.Split("$".ToCharArray())[0];
			string reason = message.Split("$".ToCharArray())[1];
			MessageBox.Show(reason,caption,MessageBoxButtons.OK);
		}
		private void sendLoginRequest()
		{
			//streamwriter.WriteLine("1"+tbUserName.Text.Trim()+"$"+tbPassword.Text.Trim()+"$");
			//streamwriter.Flush();

			sendMessage("1"+tbUserName.Text.Trim()+"$"+tbPassword.Text.Trim()+"$"+((System.Net.IPEndPoint)tcpListener.LocalEndpoint).Address.ToString()+"$"+((System.Net.IPEndPoint)tcpListener.LocalEndpoint).Port.ToString()+"$");
			userName = tbUserName.Text.Trim();
		}
		private void sendLogoutRequest()
		{
			//streamwriter.WriteLine("1"+tbUserName.Text.Trim()+"$"+tbPassword.Text.Trim()+"$");
			//streamwriter.Flush();
			sendMessage("2"+"$");
		}
		private void processOnlineUsersList(string message)
		{
			string [] userslist = message.Split("$".ToCharArray());
			for(int i=0;i<userslist.Length-1;i++)
			{
				lbClients.Items.Add(userslist[i]);
			}
			this.Text = userName;
			//if(userslist != null && userslist.Length > 0)
			//	lbClients.DataSource = userslist;	
		}
		public void fileReceivedMessage(string clientName)
		{
			MessageBox.Show("A new file received from " + clientName,"File Received!");
		}
		public void fileSavedMessage(string fileName)
		{
			MessageBox.Show("File Saved Sucessfully at c:\\temp\\"+fileName,"File Saved!");
		}
		private void button2_Click(object sender, System.EventArgs e)
		{
			
		}

		private void button3_Click(object sender, System.EventArgs e)
		{
			button3.Enabled = false;
			button1.Enabled = true;
			button2.Enabled = false;
			button4.Enabled = false;

			lbClients.Items.Clear();
			lbClients.Update();

			lbFiles.Items.Clear();
			lbFiles.Update();

			this.Text = "~Disconnected";
			sendLogoutRequest();
		}

		private void button2_Click_1(object sender, System.EventArgs e)
		{
			if(lbClients.SelectedIndex != -1)
			{
				if(!privateChatWindows.Contains(lbClients.SelectedItem.ToString()))
				{
					frmChatWindow chatWindow = new frmChatWindow(lbClients.SelectedItem.ToString(),this);
					chatWindow.Visible = true;
					chatWindow.Text +=  "~" + lbClients.SelectedItem.ToString();
					privateChatWindows.Add(lbClients.SelectedItem.ToString(),chatWindow);
				}
				else
				{
					frmChatWindow chatWindow = (frmChatWindow) privateChatWindows[lbClients.SelectedItem.ToString()];
					chatWindow.Visible = true;
					chatWindow.Activate();
				}
			}	
		}

		private void button4_Click(object sender, System.EventArgs e)
		{
			if(lbClients.SelectedIndex != -1)
			{
				//send a message to the server to get the IP Address and Port of the client
				sendMessage("a" + lbClients.SelectedItem.ToString() + "$");
				//openFileDialog1.ShowDialog();
			}
		}

		private void openFileDialog1_FileOk(object sender, System.ComponentModel.CancelEventArgs e)
		{
			System.IO.FileStream inFile;     
			byte [] binaryData = null;
			if(openFileDialog1.CheckFileExists)
			{
				try
				{
					inFile = (FileStream) openFileDialog1.OpenFile();
					binaryData = new Byte[inFile.Length];
					long bytesRead = inFile.Read(binaryData, 0,
						(int)inFile.Length);
					
					fileName = openFileDialog1.FileName.Substring(openFileDialog1.FileName.LastIndexOf('\\')+1);
					
					inFile.Close();
				}
				catch(Exception ex)
				{
				}

				try 
				{
					base64String = 
						System.Convert.ToBase64String(binaryData, 
						0,
						binaryData.Length);
					hashValue = Protocol.SimpleHash.ComputeHash(base64String,"MD5",null);
				}
				catch (System.ArgumentNullException) 
				{

				}
				catch(Exception ex)
				{
				
				}
				Thread sendingThread = new Thread(new ThreadStart(sendFile));
				sendingThread.Name = "File Sending Thread";
				sendingThread.Start();
			}
		}

		private void frmMain_Closing(object sender, System.ComponentModel.CancelEventArgs e)
		{
			sendLogoutRequest();
		}
//To request a file from Server
		private void button5_Click(object sender, System.EventArgs e)
		{
			if(lbFiles.SelectedIndex != -1)
			{
				string fileName = lbFiles.SelectedItem.ToString();
				//Sends the message to the server to download the file
				sendMessage("n"+((System.Net.IPEndPoint)tcpListener.LocalEndpoint).Address.ToString()+"$"+fileName+"$");
				
			}
		}
	}
}
